2004-11-17 Bogdan Gheorghe 
	Fix for Bug 78678: Indexer stops reindexing file after repeated saves
	
	* index/org/eclipse/cdt/internal/core/search/processing/JobManager.java
	
	
2004-11-12 Bogdan Gheorghe
	Fix for Bug 78414: IProblem count increased through indexing header files stand-alone
	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexAllProject.java
	* index/org/eclipse/cdt/internal/core/search/indexing/AddCompilationUnitToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFileToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFolderToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/CleanEncounteredHeaders.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java	
	
	* parser/org/eclipse/cdt/internal/core/parser/problem/Problem.java
	
2004-11-02 Bogdan Gheorghe
	Fixed a bug in the index merge.
	
	* index/org/eclipse/cdt/internal/core/index/impl/MergeFactory.java
	
2004-11-02 Bogdan Gheorghe
	Partial Fix for Bug 74427: Indexer needs to store more info
	
	* index/org/eclipse/cdt/core/index/IIndexDelta.java	
	* index/org/eclipse/cdt/internal/core/index/IEntryResult.java	
	* index/org/eclipse/cdt/internal/core/index/IIndexerOutput.java
	* index/org/eclipse/cdt/internal/core/index/impl/BlocksIndexInput.java
	* index/org/eclipse/cdt/internal/core/index/impl/EntryResult.java	
	* index/org/eclipse/cdt/internal/core/index/impl/GammaCompressedIndexBlock.java	
	* index/org/eclipse/cdt/internal/core/index/impl/IIndexConstants.java
	* index/org/eclipse/cdt/internal/core/index/impl/IncludeEntry.java	
	* index/org/eclipse/cdt/internal/core/index/impl/Index.java	
	* index/org/eclipse/cdt/internal/core/index/impl/IndexDelta.java	
	* index/org/eclipse/cdt/internal/core/index/impl/IndexedFileHashedArray.java	
	* index/org/eclipse/cdt/internal/core/index/impl/IndexerOutput.java	
	* index/org/eclipse/cdt/internal/core/index/impl/InMemoryIndex.java	
	* index/org/eclipse/cdt/internal/core/index/impl/MergeFactory.java	
	* index/org/eclipse/cdt/internal/core/index/impl/Util.java	
	* index/org/eclipse/cdt/internal/core/index/impl/WordEntry.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
	* index/org/eclipse/cdt/internal/core/search/indexing/AddCompilationUnitToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFileToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFolderToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/CleanEncounteredHeaders.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexerModelListener.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexer.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java	
	* dependency/org/eclipse/cdt/internal/core/sourcedependency/UpdateDependency.java	
	* model/org/eclipse/cdt/internal/core/model/DeltaProcessor.java	
	
2004-08-19 Bogdan Gheorghe
	Fix for Bug 71500: [Indexer] all headers get indexed on project open
	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddCompilationUnitToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFileToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFolderToIndex.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/CleanEncounteredHeaders.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexerModelListener.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java	
	* dependency/org/eclipse/cdt/internal/core/sourcedependency/UpdateDependency.java	
	* model/org/eclipse/cdt/internal/core/model/DeltaProcessor.java	
	
2004-08-11 Bogdan Gheorghe
	Fix for Bug 59493: need to refine index query for open-type 

	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/IIndexConstants.java	
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java	
	
	
2004-07-12 Bogdan Gheorghe
	Fix for Bug 69166: NPE in IndexerModelListener.processDelta
	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexerModelListener.java	
	
2004-07-06 Bogdan Gheorghe
	Added timing for merge operations - controlled by Indexer tracing option
	Modified removeSourceFolderFromIndex in IndexManager to take an IProject
	
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java	
	* index/org/eclipse/cdt/internal/core/index/impl/MergeFactory.java
		
2004-06-28 Bogdan Gheorghe
	Fix for Bug 60948: indexer should pick up all headers in include path
	
2004-06-25 Bogdan Gheorghe
	Indirect fix for Bug 65551: [Search] Search for Variable references should not include parameters
	Instead of excluding parameter references from searches, added parm declarations to the index (for
	both functions and methods)
	
	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
	
2004-06-22 Alain Magloire

	Part of PR 68246.
	Close the inputstream to release resource handle
	when we done with it, we can not rely on the GC to do it for us.

	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexer.java

2004-06-21 Andrew Niefer
	enable reporting of semantic problems:
		* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java
		* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexer.java
		* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java

2004-06-21 Alain Magloire

	IndexManager, call CCorePlugin.getCDescriptor(.., false).
	The boolean says to the DescriptorManager to not create the file
	if it does not exists.

2004-06-18 Alain Magloire
	- The call CCorePlugin.getCDescriptor(..) seems to return null.
	This should be fix but meanwhile give the indexer a break by catching it.

2004-06-18 Andrew Niefer
	- call InderManager.jobFinishedNotification( this ) from IndexRequest.cancel() so that the IndexManager's jobSet doesn't 
	  become stale.
	- in JobManager.discardJobs, move getting the old enabledState into the synchronized block so that we can be sure its 
	  reset correctly

2004-06-16 Bogdan Gheorghe
	- Removed reporting index failed messages from log
	
2004-06-14 Andrew Niefer
	- Bugs 66799, 66981 : don't process indexer jobs if the indexer for that project is disabled.
	- also fix warnings about deprecated calls and unnecessary else statements

2004-06-13 Bogdan Gheorghe
	Fix for Bug 63275 - Ensured that only declarations and references are found for enumerations/enumerators
	
2004-05-28 Bogdan Gheorghe
    Fix for Bug 63831 - Ability to determine when the index is incomplete
    Provided a way for external clients to query the index state of a project
    
2004-05-28 Bogdan Gheorghe
	Fix for Bug 60946 - [Indexer] indexer should provide notification whenever index changes
	Provide a notification to the listener of index events

	Fix for Bug 44926 - add extensibility to gracefully handle preprocessor exceptions
	Added an IndexProblemHandler to handle parser IProblem callbacks

2004-05-27 Bogdan Gheorghe
	Fix for Bug 58716 - [Refactoring] Subdirectories confuse refactoring
	Added a listener to path change events from the core model; retrigger 
	indexing based on the granularity of the change event
	
2004-05-27 Bogdan Gheorghe
	Fix for Bug 62015 - Indexer to not rely on file extension for translation Unit
	Changed all indexer file type checking to use the CoreModel file resolution services.
	
2004-05-21 Andrew Niefer
	Indexer problem reporting
		* index/org/eclipse/cdt/internal/core/messages.properties
		* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java
		* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexer.java
		* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java

2004-05-18 Bogdan Gheorghe
	IndexAllProject - restored the save request.
	
2004-05-18 Bogdan Gheorghe
	First go at putting in source folder indexing. Index All events will index
	source folders (still need to put in includes indexing). DeltaProcessor only
	forwards events for source files so individual indexing doesn't need to be
 	altered. 
 	
2004-05-16 Bogdan Gheorghe
    Fix for bug 61332 - make sure that the timer is ready to go before starting
    a new index
       
2004-05-07 Bogdan Gheorghe
	Modified indexer friend encoding to encode IASTElaboratedTypeSpecifier
	
2004-05-06 Bogdan Gheorghe
	Modified AbstractIndexer to encode friends, add friends constant to IIndexConstants,
	modified SourceIndexerRequestor to add class specifier on exit instead of enter in order
	to be able to encode friends.
	
2004-05-05 Bogdan Gheorghe
	Added code to load and store index enablement setting from a project's descriptor
	
2004-05-03 Bogdan Gheorghe
	Added index enablement checking to index manager
	
2004-04-20 Bogdan Gheorghe
	Fix for Bug 54155
	
2004-04-12 Bogdan Gheorghe
	Added Indexer watchdog
	
2004-04-12 Bogdan Gheorghe
	Added Enumerator and Derived types to index
	
2004-03-31 Bogdan Gheorghe
	Added a check to SourceIndexRequestor.removeMarkers to prevent hang.
	
2004-03-31 Bogdan Gheorghe
	Modified SourceIndexer and SourceIndexerRequestor to place IProblem markers
	on resources.
	
2004-03-15 Andrew Niefer
	updated SourceIndexerRequestor with acceptTemplateParameterReference

2004-03-04 Bogdan Gheorghe
	Modified SourceIndexer to use BufferedReaders instead of passing in a char array.

2004-02-13 Bogdan Gheorghe
	PR 51232

	- Added mapping range checking to IncludeEntry to avoid out of bounds exceptions
	- Added error handling to MergeFactory to handle problems during the save operation
	- Added source file name filtering for the recreate an already existing index scenario in
	  IndexAllProject. 
	- Added more robust error handling to SourceIndexer
	- Added error handling routine to Util.getFileCharContent() to deal with potential out of 
	  memory crash
	
	* index/org/eclipse/cdt/internal/core/index/impl/IncludeEntry.java
	* index/org/eclipse/cdt/internal/core/index/impl/MergeFactory.java
	* index/org/eclipse/cdt/internal/core/index/search/Util.java
	* index/org/eclipse/cdt/internal/core/index/search/indexing/IndexAllProject.java
	* index/org/eclipse/cdt/internal/core/index/search/indexing/SourceIndexer.java
	* index/org/eclipse/cdt/internal/core/index/search/indexing/AddFolderToIndex.java
	
2004-02-10 Bogdan Gheorghe
	
	- Modified some of the stored index block reading routines to use separate
	  counters, thus avoiding potential EOF exceptions.
	  
    * index/org/eclipse/cdt/internal/core/index/impl/BlocksIndexInput.java
    
2004-02-03 Alain Magloire

	PR 51106                                                                                                                   
    Patches from Thomas Fletcher dealing with the indexer.

    - Remove assumed throw/catch of an exception to be a regular occurance
    and replace with explicit test and return for bounds access to the
    particular array.
                                                                                                                             
    - Consider references outside of the mapping range the same as no longer
    valid mappings (ie -1 entries) and avoid array range exceptions.
                                                                                                                             
    * index/org/eclipse/cdt/internal/core/index/impl/WordEntry.java
    * index/org/eclipse/cdt/internal/core/index/impl/FileListBlock.java

2004-01-26 John Camelon
	Updated clients to use new Scanner logging service.
	
2003-10-22 Bogdan Gheorghe
	
	Added updateDependencies() to the IndexManager to request
	a new UpdateDependency job.
	
2003-10-01 Bogdan Gheorghe
	- Modified BlockIndexOutput.addInclude to properly flush an
	include block once it's full.
	- Flushing the CDT log after every merge
	- Logging I/O Exceptions in AddFileToIndex
	- Changed valid source file extensions in SourceIndexer to
	  use CModelManager file extensions
	
2003-09-30 Bogdan Gheorghe
	Changed logging for SourceIndexer to log file in cdt.core
	
2003-09-25 Bogdan Gheorghe
	Integrated the dependency service into the indexer. Changes
	as follows:
	
	org.eclipse.cdt.internal.core.index.impl:
	* IIndex - added getFileDependencies methods
	* IIndexerOutput - modified to allow dep inputs into the index
	* BlocksIndexInput - modified to allow the reading of the new index (which includes dep entries)
	* BlocksIndexOutput - added facilities to write includes to the index
	* GammaCompressedIndexBlock - modified with addIncludeEntry() and nextEntry()
	* IncludeEntry - new file
	* IncludeEntryHashedArray - new file
	* Index - Added getFileDepenendencies to query includeEntries from the index
	* IndexBlock - modified to reflect changes in GammaCompressedIndexBlock
	* IndexerOutput - added new methods from IIndexerOutput
	* IndexInput - modified to allow reading of includes from index files
	* IndexSummary - modified to save/read new format which contains include info
	* InMemoryIndex - modified InMemoryIndex to keep track of includes
	* MergeFactory - modified MergeFactory to accomodate new index file format
	* SimpleIndexInput - modified to use the new functions for includes in InMemoryIndex
	* Util - Added a quickSort for includeEntry[]
	
	org.eclipse.cdt.internal.core.search.indexing:
	* AbstractIndexer - modified to getResourceFile being indexed, added bestIncludePrefix 
	  to find include table entries, addInclude() which accepts IASTInclusion node and adds it
	  to the index
	* IIndexConstants - added includeRef constant
	* IndexManager - got rid of all dependency table references
	* SourceIndexer - modified to return resource being indexed
	* SourceIndexerRequestor - Added inclusion handling code; stack for includes
	
	
2003-09-22 Bogdan Gheorghe
	
	Took out the old CTags Indexer. Modified IndexAllProject to get
	the project path straight from the resource (bypassing the CModelManager).
	Commented out the enable section in IndexManager.
	
	Modified
	* org.eclipse.cdt.internal.core.search.indexing.IndexAllProject
	* org.eclipse.cdt.internal.core.search.indexing.IndexManager
	
	Deleted
	* org.eclipse.cdt.core.index.IndexModel
	* org.eclipse.cdt.core.index.ITagEntry
	* org.eclipse.cdt.core.index.TagFlags
	* org.eclipse.cdt.internal.core.index.CTagsCmd
	* org.eclipse.cdt.internal.core.index.CTagsEntry
	* org.eclipse.cdt.internal.core.index.CTagsFileReader
	* org.eclipse.cdt.internal.core.index.CTagsFileWriter
	* org.eclipse.cdt.internal.core.index.CTagsHeader
	* org.eclipse.cdt.internal.core.index.CTagsRunner
	* org.eclipse.cdt.internal.core.index.IndexManager
	* org.eclipse.cdt.internal.core.index.RequestList
	
2003-09-16 Andrew Niefer
	- add parameter references to index
	- modify CharOperation.match to allow escaping wildcards (bug43063)
	- modify AbstractIndexer.bestPrefix to handle wildcard escaping in name (bug43063)

2003-09-13 Andrew Niefer
	- add Typedefs to index as Types with suffix T (bug42902)
		- added addTypedefReference to AbstractIndexer
		- modified bestTypePrefix in AbstractIndexer
		- added TYPEDEF_DECL, TYPEDEF_SUFFIX to IIndexConstants
		- modified acceptTypedefReference in SourceIndexerRequestor

2003-09-09 Andrew Niefer
	Enumerator references
 	 - Added createEnumeratorFullyQualifiedName in AbstractIndexer
	 - Added addEnumeratorReference in AbstractIndexer
	 - implemented acceptEnumeratorReference in SourceIndexerRequestor

2003-09-08 Andrew Niefer
	- Modified calls to ParserFactory to specify which language to use

2003-09-05 Andrew Niefer
	- Modified how AbstractIndexer creates the fully qualified name for an enumerator (spec 7.2-10)

2003-08-26 Bogdan Gheorghe
	- Removed header file extensions from being indexed (they
	  will be indexed via inclusion)
	
2003-08-20 Bogdan Gheorghe
	- Added debug tracing in AbstractIndexer
	- Added additional file extensions to supported indexed files
	- Changed the parser instantiation to pass in retrieved build
	  info
	- Added function decl index entry based on enterFunctionBody
	- Added method decl index entry based on enterMethodBody
	- Added forward decl refs
	
2003-08-14 Bogdan Gheorghe
	- Added forward declarations to index
	
2003-08-12 Bogdan Gheorghe
	- Changed var prefix in AbstractIndexer to pass in fully
	  qualified names
	  
2003-08-11 Bogdan Gheorghe
	- Added macro declarations to the index
	- Added macro prefix to AbstractIndexer
	
2003-08-07 Bogdan Gheorghe
	- Added shutdown cleanup routine in IndexManager
	
2003-07-28 Andrew Niefer
	- added support for '?' wildcards in AbstractIndexer.bestPrefix

2003-07-25 Bogdan Gheorghe
	- Changed parser to COMPLETE mode
	- Added functionRef, methodRef, typeRef, namespaceRef, fieldRef
	
	Modified:
	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IIndexConstants.java
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexer.java
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java
	
	
2003-07-24 Andrew Niefer
	- added TYPE_ALL, FUNCTION_ALL, METHOD_ALL, NAMESPACE_ALL, FIELD_ALL constants to IIndexConstants
	- modified AbstractIndexer prefix functions to properly handle searching for all occurences
	
2003-07-23 Andrew Niefer
	Modified 
	*index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
		-changed so that the index prefixes contain the qualified names of the 
		 elements in reverse order.
		-Added functions:
			bestVariablePrefix
			bestNamespacePrefix
			bestFieldPrefix
			bestFunctionPrefix
			bestMethodPrefix

2003-07-21 Bogdan Gheorghe
	Added additional declarations to index: enums, enumerators, namespace,
	functions, vars, methods, fields, typedefs.
	
	Fixed IndexManager to prevent individually added files from
	being added to the index if indexing is not enabled for the project
	
	Modified:
	
	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IIndexConstants.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java
	
2003-07-10 Bogdan Gheorghe
	Added bestTypeDeclarationPrefix to AbstractIndexer to allow the
	search engine to create a query string for the index.
	Changed encoding in AbstractIndexer to encode fully qualified names.
	
	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
	
2003-07-03 Bogdan Gheorghe
	Updated copyright notices.
	
2003-06-25 Bogdan Gheorghe
	Added new Indexer framework:
	
	* index/org/eclipse/cdt/internal/core/index/IDocument.java
	* index/org/eclipse/cdt/internal/core/index/IEntryResult.java
	* index/org/eclipse/cdt/internal/core/index/IIndex.java
	* index/org/eclipse/cdt/internal/core/index/IIndexer.java
	* index/org/eclipse/cdt/internal/core/index/IIndexerOutput.java
	* index/org/eclipse/cdt/internal/core/index/IQueryResult.java
	
	* index/org/eclipse/cdt/internal/core/index/impl/Block.java
	* index/org/eclipse/cdt/internal/core/index/impl/BlocksIndexInput.java
	* index/org/eclipse/cdt/internal/core/index/impl/BlocksIndexOutput.java
	* index/org/eclipse/cdt/internal/core/index/impl/CodeByteStream.java
	* index/org/eclipse/cdt/internal/core/index/impl/EntryResult.java
	* index/org/eclipse/cdt/internal/core/index/impl/Field.java
	* index/org/eclipse/cdt/internal/core/index/impl/GammaCompressedIndexBlock.java
	* index/org/eclipse/cdt/internal/core/index/impl/IFileDocument.java
	* index/org/eclipse/cdt/internal/core/index/impl/IIndexConstants.java
	* index/org/eclipse/cdt/internal/core/index/impl/Index.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexBlock.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexedFile.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexedFileHashedArray.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexerOutput.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexInput.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexOutput.java
	* index/org/eclipse/cdt/internal/core/index/impl/IndexSummary.java
	* index/org/eclipse/cdt/internal/core/index/impl/InMemoryIndex.java
	* index/org/eclipse/cdt/internal/core/index/impl/Int.java
	* index/org/eclipse/cdt/internal/core/index/impl/MergeFactory.java
	* index/org/eclipse/cdt/internal/core/index/impl/PropertyDocument.java
	* index/org/eclipse/cdt/internal/core/index/impl/SafeRandomAccessFile.java
	* index/org/eclipse/cdt/internal/core/index/impl/SimpleIndexInput.java
	* index/org/eclipse/cdt/internal/core/index/impl/Util.java
	* index/org/eclipse/cdt/internal/core/index/impl/WordEntry.java
	* index/org/eclipse/cdt/internal/core/index/impl/WordEntryHashedArray.java

	* index/org/eclipse/cdt/internal/core/search/CharOperation.java
	* index/org/eclipse/cdt/internal/core/search/HashtableOfInt.java
	* index/org/eclipse/cdt/internal/core/search/SimpleLookupTable.java
	* index/org/eclipse/cdt/internal/core/search/Util.java
	* index/org/eclipse/cdt/internal/core/search/message.properties

	* index/org/eclipse/cdt/internal/core/search/indexing/AbstractIndexer.java
	* index/org/eclipse/cdt/internal/core/search/indexing/AddCompilationUnitToIndex.java
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFileToIndex.java
	* index/org/eclipse/cdt/internal/core/search/indexing/AddFolderToIndex.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IIndexConstants.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexAllProject.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexManager.java
	* index/org/eclipse/cdt/internal/core/search/indexing/IndexRequest.java
	* index/org/eclipse/cdt/internal/core/search/indexing/ReadWriteMonitor.java
	* index/org/eclipse/cdt/internal/core/search/indexing/RemoveFolderFromIndex.java
	* index/org/eclipse/cdt/internal/core/search/indexing/RemoveFromIndex.java
	* index/org/eclipse/cdt/internal/core/search/indexing/SaveIndex.java
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexer.java
	* index/org/eclipse/cdt/internal/core/search/indexing/SourceIndexerRequestor.java

	